; Very old Cottontail boot code, hacked up a bit to work with the Cottontail Bootloader.
; Scotch-tape everywhere, and very messy, but at least it works!
; 1.44MB floppies with FAT12 only. I'll fix this someday.

; by: Frank Millea

%define __BOOT_144__

%define LOAD_BASE 0x800
%define RD_BUF 0x8000
%define FAT_BUF 0x8000

org 0x7C00

jmp short boot_code
nop

%ifdef __BOOT_144__
bs_oem_name 		db "MSWIN4.0"
bs_bytes_per_sect 	dw 0x200
bs_sects_per_clust 	db 1
bs_reserved_sects 	dw 1
bs_num_fats 		db 2
bs_root_dir_entries 	dw 0xE0
bs_sects 		dw 0xB40
bs_media 		db 0xF0
bs_fat_sects 		dw 9
bs_sects_per_track 	dw 0x12
bs_heads 		dw 2
bs_hidden_sec	 	dd 0
bs_huge_sects		dd 0
bs_drive_num		db 0
bs_reserved 		db 0
bs_boot_signature 	db 0x29
bs_volume_id 		dd 0x00007C00
bs_volume_label 	db "COTTONTAIL0"
bs_fs_type 		db "FAT     "
%endif

boot_code:

	cli
	mov ax, cs
	mov ds, ax
	mov es, ax
	mov ss, ax
	xor sp, sp
	mov [bs_drive_num], dl	; save the drive number (useful if we are booting from a floppy in a multiple-floppy system)
	xor edx, edx
	sti

	mov si, 0x7C00	; make a copy of the boot sector at 0:600
	mov di, 0x600
	mov cx, 0x200
	rep movsb

	mov si, boot_msg
	call prints

	mov ax, [bs_root_dir_entries]
	shl ax, 5	; * 32
	mov di, ax	; save max. root directory memory location
	add di, RD_BUF
	shr ax, 9	; / 512 - calculate number of root directory sectors we will need to read in
	push ax	; and save it
	xor ax, ax
	mov al, [bs_num_fats]
	mov bx, [bs_fat_sects]
	mul bx
	add ax, [bs_reserved_sects]	; calculate first root directory sector
	push ax	; save ax
	call trans_log_phys	; translate logical sector in ax to physical sector mappings the BIOS can use
	pop bx	; get in it bx
	pop ax	; restore number of root directory sectors to read
	add bx, ax	; calculate first logical sector
	push ax
	xor ax, ax
	mov al, [bs_sects_per_clust]
	shl ax, 1	; multiply it by 2
	sub bx, ax
	pop ax
	mov [first_logical_sect], bx	; save it
	mov ah, 2	; read operation
	mov dl, [bs_drive_num]	; drive number
	mov bx, RD_BUF
	call int13_with_retry
	mov si, RD_BUF
	find_file_L1:
	cmp si, di	; at end of root directory?
	jne file_not_found_N1
	jmp boot_error
	file_not_found_N1:
	xor bx, bx
	strcmp_L1:
	cmp bx, 11	; have we already compared 11 bytes OK?
	je find_file_D1
	mov al, [si+bx]
	cmp [filename+bx], al
	jne strcmp_D1
	inc bx
	jmp short strcmp_L1
	strcmp_D1:
	add si, 0x20	; next root directory entry
	jmp short find_file_L1
	find_file_D1:	; found the file
	mov dx, [si+26]	; get start cluster for file
	fat_loop:
	cmp dx, 0xFF8	; done yet?
	jl not_fat_done
	mov dl, [bs_drive_num]
	mov bx, 0x600
	cli	; disable interrupts
	jmp 0000:LOAD_BASE	; jump to file
	not_fat_done:
	mov ax, dx
	xor bx, bx
	mov bl, [bs_sects_per_clust]
	push dx	; save current FAT entry
	mul bx	; and multiply it by bx to get sectors
	add ax, [first_logical_sect]	; now we have the logical sector to read
	call trans_log_phys	; translate logical to physical
	push es
	mov eax, [dest]
	push eax
	shr eax, 4
	mov es, ax	; get segment
	pop eax
	and ax, 0xF
	mov bx, ax	; get offset
	mov al, [bs_sects_per_clust]	; read the entire cluster
	mov ah, 2	; read operation
	mov dl, [bs_drive_num]	; set drive
	call int13_with_retry	; do it
	pop es
	xor eax, eax
	mov al, [bs_sects_per_clust]
	shl eax, 9	; get bytes we just read in
	add [dest], eax	; add it to the destination pointer
	pop dx	; get current FAT entry again
	mov eax, edx
	mov ebx, 3
	mul ebx	; * 3
	push eax	; eax will need to be / 2 to get the 32-bit offset into the FAT
	shr eax, 10	; / 1024 - we now have the FAT sector in ax
	add ax, [bs_reserved_sects]
	cmp ax, [fat_sect]	; do we already have that sector in memory?
	je fat_sect_ok
	mov [fat_sect], ax	; new fat_sect
	call trans_log_phys
	mov ah, 2	; read operation
	mov al, 2	; read 2 sectors (FAT12 entries can straddle a sector boundary)
	mov bx, FAT_BUF	; FAT buffer
	mov dl, [bs_drive_num]
	call int13_with_retry
	fat_sect_ok:
	pop ebx
	push ebx
	shr ebx, 1	; / 2 to get offset
	and bx, 0x1FF	; isolate the offset within the current FAT sector
	mov dx, [FAT_BUF+bx]	; get the FAT entry
	pop eax
	and ax, 1	; check odd/even
	jz even
	shr dx, 4
	jmp short odd
	even:
	and dx, 0x0FFF
	odd:
	jmp fat_loop

trans_log_phys:		; translates the logical sector in ax to BIOS-compatible values in cl, ch, and dh

	push bx
	mov bx, [bs_sects_per_track]
	push bx	; sects per track on the stack now
	push ax
	mov ax, [bs_heads]
	mul bx
	mov bx, ax	; i.e. 36
	pop ax		; original LBA
	xor dx, dx
	div bx
	mov ch, al	; cylinder/track
	shl ah, 6
	mov cl, ah	; high 2 bits of cylinder
	mov ax, dx	; save remainder
	xor dx, dx
	pop bx	; get sects per track off the stack
	div bx
	mov dh, al	; head
	inc dl
	or cl, dl	; sector
	pop bx
	ret

int13_with_retry:

	push si
	push ax	; save ax and si
	xor si, si
	push si
	int13_L1:
	int 0x13	; call int 13H
	jnc int13_D1	; if no error
	pop si
	inc si
	push si
	cmp si, 3	; have we retried 3 times?
	jne no_disk_error
	jmp boot_error
	no_disk_error:
;	xor ah, ah
;	mov dl, [bs_drive_num]
;	int 0x13	; otherwise, reset the drive and retry
	pop ax
	push ax
	jmp short int13_L1
	int13_D1:
	pop si
	pop ax	; restore ax and si
	pop si
	ret

prints:
	cld
	lodsb
	or al, al
	jz prints_D1
	mov ah, 0x0E
	mov bx, 3
	int 0x10
	jmp short prints
	prints_D1:
	ret

boot_error:
	
	jmp short $

boot_msg: db "boot17-12", 13, 0

filename: db "CBL     BIN"
dest: dd LOAD_BASE
first_logical_sect: dw 0
fat_sect: dw 0xFFFF	; the FAT sector currently in the buffer
